SystemOrganization addCategory: #'TADP TP1'!

Trait named: #TraitAgenda
	uses: {}
	category: 'TADP TP1'!

!TraitAgenda methodsFor: 'printing' stamp: 'ArielCapozzoli 4/21/2012 00:51'!
agendarReunion: unaReunion
	|evento|.
	evento := Evento new.
	evento horaInicio: unaReunion horaInicio.	
	evento horaFin: unaReunion horaFin.
	(self agenda) agregarEvento: evento.! !

!TraitAgenda methodsFor: 'printing' stamp: 'ArielCapozzoli 4/21/2012 00:49'!
recorrerAgendaEnDia: unaFecha
	^ (self agenda) eventosEnLaFecha: unaFecha.
		! !

Trait named: #TraitFiltro
	uses: {}
	category: 'TADP TP1'!

Object subclass: #Agenda
	instanceVariableNames: 'eventos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:38'!
agregarEvento:unEvento
	eventos add: unEvento.
	"eventos sort."! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 23:26'!
eventos
	^(eventos sort)! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:28'!
eventos: anObject
	eventos := anObject.
	"eventos sort."! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 02:05'!
eventosEnLaFecha:unaFecha
	^eventos select:[:unEvento | unEvento fecha = unaFecha ]! !

!Agenda methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/6/2012 15:22'!
initialize 
	eventos:= OrderedCollection new.! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 00:11'!
tiemposLibresQueDurenComoMinimo:unaDuracion
	|i tiemposLibres evt|
	i:=1.
	tiemposLibres := OrderedCollection new.	
	((eventos size) -1) timesRepeat:
	[
		((eventos at: i) horaFin addTime: unaDuracion) < (eventos at: i+1) horaInicio
		 ifTrue: [
			evt:=Evento new.
			evt fecha: (eventos at: i).
			evt horaInicio: (eventos at: i) horaFin.
			evt horaFin: (eventos at: i+1) horaInicio.
			tiemposLibres add: evt].
			i:=i+1.
		].
	^tiemposLibres.! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 16:09'!
tieneTiempoLibreParaElEvento:unEvento
	^ unEvento seSuperPoneConAlgunOtroEvento: (self eventos).! !

Object subclass: #Edificio
	instanceVariableNames: 'nombre salas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Edificio methodsFor: 'accessing' stamp: 'NahuelBarroso 4/21/2012 00:05'!
agregarSala: aSala
	self salas add: aSala.! !

!Edificio methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/21/2012 00:48'!
buscaUnaSalaXEvento: anEvento

	^self salas detect:[:each | each estasLibreEnEsteEvento: anEvento].! !

!Edificio methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/21/2012 00:01'!
initialize
	salas := OrderedCollection new.
	! !

!Edificio methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:02'!
nombre
	^ nombre! !

!Edificio methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:02'!
nombre: anObject
	nombre := anObject! !

!Edificio methodsFor: 'accessing' stamp: 'NahuelBarroso 4/20/2012 23:47'!
salas
	^ salas! !

Object subclass: #Empresa
	instanceVariableNames: 'edificios herramientas personas proyectos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Empresa methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 00:46'!
agregarPersona: aPersona 
	self personas add: aPersona.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 00:39'!
agregarProyecto: unProyecto 
	(self proyectos) add: unProyecto.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ArielCapozzoli 4/21/2012 01:16'!
buscaSalaXEvento: anEvento
|sala|
	self edificios do: [:edificio| sala = edificio buscaUnaSalaXEvento: anEvento. sala ifNotNilDo: [^sala] ].
	^false
! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/20/2012 19:11'!
buscarPersonasRequeridas: filtros
	|idxFiltro personasRequeridas|
	filtros do: [:unFiltro | unFiltro buscarPersonaQueTeCumple: personas].
	personasRequeridas:= filtros collect:[:unFiltro | unFiltro personaQueCumple].
	(personasRequeridas includes: nil) ifTrue: [^'No se pudieron obtener personas para uno de los filtro']
	 ifFalse: [^personasRequeridas].
! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
edificios
	^ edificios! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
edificios: anObject
	edificios := anObject! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
herramientas
	^ herramientas! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
herramientas: anObject
	herramientas := anObject! !

!Empresa methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:38'!
initialize 
	personas:= OrderedCollection new.
	herramientas:= OrderedCollection new.
	proyectos:= OrderedCollection new.
	edificios:= OrderedCollection new.! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
personas
	^ personas! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
personas: anObject
	personas := anObject! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
proyectos
	^ proyectos! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
proyectos: anObject
	proyectos := anObject! !

Object subclass: #Evento
	instanceVariableNames: 'horaInicio horaFin fecha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 23:33'!
<=otroEvento
	(self fecha = otroEvento fecha) ifTrue:[^(self horaInicio <= otroEvento horaInicio)] ifFalse: [^(self fecha <= otroEvento fecha)].
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 00:43'!
fecha
	^ fecha! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 01:12'!
fecha: anObject
	fecha := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 15:51'!
fecha: fechaEvento horaInicio:horaInicioEvento horaFin:horaFinEvento
	self fecha: (Date readFrom: fechaEvento readStream).
	self horaInicio: (Time readFrom: horaInicioEvento readStream).
	self horaFin: (Time readFrom: horaFinEvento readStream).! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaFin
	^ horaFin! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaFin: anObject
	horaFin := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaInicio
	^ horaInicio! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 01:12'!
horaInicio: anObject
	horaInicio := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 15:31'!
seSuperPoneCon:otroEvento
	(self == otroEvento) ifFalse:[ ^(((self horaInicio > otroEvento horaFin) | (self horaFin < otroEvento horaInicio)) not)]
	ifTrue: [^false] ! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 15:29'!
seSuperPoneConAlgunOtroEvento:unaColeccionDeEventos
	^ unaColeccionDeEventos anySatisfy: [:unEvento | unEvento seSuperPoneCon: self].
! !

Object subclass: #FiltroNombre
	uses: TraitFiltro
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

FiltroNombre class
	uses: TraitFiltro classTrait
	instanceVariableNames: ''!

!FiltroNombre methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 01:24'!
esCumplidoPor: aPersona 
	^nombre = (aPersona nombre).! !

!FiltroNombre methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:43'!
nombre
	^ nombre! !

!FiltroNombre methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:43'!
nombre: anObject
	nombre := anObject! !

Object subclass: #FiltroPersona
	instanceVariableNames: 'filtros personaQueCumple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!FiltroPersona methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 00:49'!
agregarFiltro: unFiltro
	(self filtros) add: unFiltro.! !

!FiltroPersona methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/20/2012 18:38'!
buscarPersonaQueTeCumple: personas
	|personasQueCumplen|
	personasQueCumplen := personas select: [:unaPersona | unaPersona pasasElFiltro: self].
	(personasQueCumplen) size > 0 ifTrue: [ self personaQueCumple: (personasQueCumplen first) ]
									ifFalse: [ self personaQueCumple: nil ].! !

!FiltroPersona methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:44'!
filtros
	^ filtros! !

!FiltroPersona methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:44'!
filtros: anObject
	filtros := anObject! !

!FiltroPersona methodsFor: 'accessing' stamp: 'Gustavo 4/17/2012 00:29'!
initialize
	filtros:= OrderedCollection new.
	persona:= nil.! !

!FiltroPersona methodsFor: 'accessing' stamp: 'Gustavo 4/17/2012 00:39'!
personaQueCumple
	^ personaQueCumple! !

!FiltroPersona methodsFor: 'accessing' stamp: 'Gustavo 4/17/2012 00:39'!
personaQueCumple: anObject
	personaQueCumple := anObject! !

Object subclass: #FiltroProyecto
	uses: TraitFiltro
	instanceVariableNames: 'proyecto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

FiltroProyecto class
	uses: TraitFiltro classTrait
	instanceVariableNames: ''!

!FiltroProyecto methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 01:25'!
esCumplidoPor: aPersona 
	^aPersona trabajasEnElProyecto: proyecto.! !

!FiltroProyecto methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:44'!
proyecto
	^ proyecto! !

!FiltroProyecto methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:44'!
proyecto: anObject
	proyecto := anObject! !

Object subclass: #FiltroRol
	uses: TraitFiltro
	instanceVariableNames: 'rol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

FiltroRol class
	uses: TraitFiltro classTrait
	instanceVariableNames: ''!

!FiltroRol methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 01:31'!
esCumplidoPor: aPersona 
	^rol = (aPersona rol).! !

!FiltroRol methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:48'!
rol
	^ rol! !

!FiltroRol methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:48'!
rol: anObject
	rol := anObject! !

Object subclass: #FiltroSector
	uses: TraitFiltro
	instanceVariableNames: 'sector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

FiltroSector class
	uses: TraitFiltro classTrait
	instanceVariableNames: ''!

!FiltroSector methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/16/2012 23:08'!
esCumplidoPor: aPersona 
	^sector = (aPersona sector).! !

!FiltroSector methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:44'!
sector
	^ sector! !

!FiltroSector methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:44'!
sector: anObject
	sector := anObject! !

Object subclass: #Herramienta
	uses: TraitAgenda
	instanceVariableNames: 'costo agenda'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Herramienta class
	uses: TraitAgenda classTrait
	instanceVariableNames: ''!

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:13'!
agenda
	^ agenda! !

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:13'!
agenda: anObject
	agenda := anObject! !

!Herramienta methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 19:02'!
costo
	^ costo! !

!Herramienta methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 19:02'!
costo: anObject
	costo := anObject! !

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:22'!
initialize
	agenda := Agenda new.
	! !

Herramienta subclass: #RecursoLimitado
	instanceVariableNames: 'nombre cantidadTotal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:57'!
cantidad
	^ cantidadTotal! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:57'!
cantidad: anObject
	cantidadTotal := anObject! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:57'!
hay:unNumero paraEvento: unEvento
	| eventosEnFecha i eventoAux cantidadReservada noSumoTodavia|
	eventosEnFecha := (self agenda) recorrerAgendaEnDia: (unEvento fecha).
	i :=1.
	cantidadReservada:= 0.
	(eventosEnFecha size) timesRepeat:[
		eventoAux := eventosEnFecha at: i.
		noSumoTodavia := true.
		"si empiezan al mismo tiempo cuenta como reservado"
		(((eventoAux horaInicio)=(unEvento horaInicio))&noSumoTodavia)
		ifTrue:[
			cantidadReservada:= cantidadReservada +1.
			noSumoTodavia := false.
			].
		"si empieza despues, pero la otra no termino cuando esta empezo, cuenta como reservado"
		(((eventoAux horaInicio)<(unEvento horaInicio))&((eventoAux horaFin)>(unEvento horaInicio))&noSumoTodavia)
		ifTrue:[
			cantidadReservada:= cantidadReservada +1.
			noSumoTodavia := false.
		].
		"si la reservada empieza despues, pero esta no termino cuando la otra empezo, cuenta como reservado"
		(((eventoAux horaInicio)<(unEvento horaFin))&((eventoAux horaFin)>(unEvento horaFin))&noSumoTodavia)
		ifTrue:[
			cantidadReservada:= cantidadReservada +1.
			noSumoTodavia := false.
		].
		i:= i+1.		
	].
	unNumero<((self cantidad) - cantidadReservada)
	ifTrue:[
		^true].
	^false! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:25'!
nombre
	^ nombre! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:25'!
nombre: anObject
	nombre := anObject! !

Herramienta subclass: #Sala
	instanceVariableNames: 'nombre edificioEnElQueSeEncuentra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:03'!
edificioEnElQueSeEncuentra
	^ edificioEnElQueSeEncuentra! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:03'!
edificioEnElQueSeEncuentra: anObject
	edificioEnElQueSeEncuentra := anObject! !

!Sala methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/21/2012 00:55'!
estasLibreEnEsteEvento: anEvento

	^(self agenda tieneTiempoLibreParaElEvento: anEvento)! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 14:05'!
nombre
	^ nombre! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 14:05'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Persona
	uses: TraitAgenda
	instanceVariableNames: 'nombre horaEntrada horaSalida proyectoAlQueEstaAsignado sector rol edificioEnElQueTrabaja valorPorHoraDeTrabajo agenda'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Persona class
	uses: TraitAgenda classTrait
	instanceVariableNames: ''!

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:19'!
agenda
	^ agenda! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:19'!
agenda: anObject
	agenda := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
edificioEnElQueTrabaja
	^ edificioEnElQueTrabaja! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
edificioEnElQueTrabaja: anObject
	edificioEnElQueTrabaja := anObject! !

!Persona methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 22:11'!
horaEntrada
	^ horaEntrada! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:15'!
horaEntrada: anObject
	horaEntrada := (Time readFrom: anObject readStream)! !

!Persona methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 22:11'!
horaSalida
	^ horaSalida! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:15'!
horaSalida: anObject
	horaSalida := (Time readFrom: anObject readStream)! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:22'!
initialize 
	agenda := Agenda new.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
nombre
	^ nombre! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
nombre: anObject
	nombre := anObject! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/20/2012 18:47'!
pasasElFiltro: unFiltro 
	^unFiltro filtros allSatisfy: [:filtro | filtro esCumplidoPor: self]
! !

!Persona methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/16/2012 00:27'!
proyecto
	^ proyecto! !

!Persona methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/16/2012 00:27'!
proyecto: anObject
	proyecto := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
proyectoAlQueEstaAsignado
	^ proyectoAlQueEstaAsignado! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
proyectoAlQueEstaAsignado: anObject
	proyectoAlQueEstaAsignado := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
rol
	^ rol! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
rol: anObject
	rol := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
sector
	^ sector! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
sector: anObject
	sector := anObject! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/20/2012 21:08'!
trabajasEnElProyecto: nombreProyecto 
	^(proyectoAlQueEstaAsignado nombre) = nombreProyecto.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
valorPorHoraDeTrabajo
	^ valorPorHoraDeTrabajo! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
valorPorHoraDeTrabajo: anObject
	valorPorHoraDeTrabajo := anObject! !

Object subclass: #Proyecto
	instanceVariableNames: 'nombre costo personas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 18:45'!
agregarPersona: unaPersona
	unaPersona proyectoAlQueEstaAsignado: self.
	personas add: unaPersona.! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 19:02'!
costo
	^ costo! !

!Proyecto methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/16/2012 00:27'!
costo: anObject
	costo := anObject! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 20:07'!
imputarCosto: unCosto
	costo := (costo+unCosto).! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 18:27'!
initialize 
	costo := 0.
	personas := OrderedCollection new.! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 20:04'!
nombre
	^ nombre! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 20:04'!
nombre: anObject
	nombre := anObject! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 20:01'!
personas
	^ personas! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 20:01'!
personas: anObject
	personas := anObject! !

Object subclass: #ReservaHerramienta
	instanceVariableNames: 'herramienta cantidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
cantidad
	^ cantidad! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
cantidad: anObject
	cantidad := anObject! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
herramienta
	^ herramienta! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
herramienta: anObject
	herramienta := anObject! !

Object subclass: #Reunion
	instanceVariableNames: 'personaQueLaConvoca sala herramientas requiereCatering personas proyectoQueLaRequirio horaInicio horaFin fecha duracion empresa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:56'!
AgendarEnTodos
	|i|
	i:=1.
	(personas size) timesRepeat: [
		(personas at: i) agendarReunion: self.
		i:=i +1
		]. 
	i:=1.
	(herramientas size) timesRepeat:[
		((herramientas at: i) herramienta) agendarReunion: self.
		i:= i +1.
		].
	sala agendarReunion: self.
	  
	! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 00:57'!
agregarHerramienta: unaHerramienta
	| reservaAux |
	reservaAux := ReservaHerramienta new.
	reservaAux herramienta: unaHerramienta.
	reservaAux cantidad: 1.
	herramientas add reservaAux.
	! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 00:57'!
agregarHerramienta: unaHerramienta cuantas: unNumero
	| reservaAux |
	reservaAux := ReservaHerramienta new.
	reservaAux herramienta: unaHerramienta.
	reservaAux cantidad: unNumero.
	herramientas add reservaAux.
	! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 21:15'!
calcularCosto
	|personasDeOtrosProyectos|
	personasDeOtrosProyectos := self personas select: [:unaPersona | (unaPersona trabajasEnElProyecto:  (self proyectoQueLaRequirio nombre)) not].
	
	"Imputa el costo de las Herramietas (Proyector, Laptop, etc...)"
	herramientas ifNotNil: 
		[herramientas do:[ :unaHerramienta | self proyectoQueLaRequirio imputarCosto: unaHerramienta costo]].

	"Imputa el costo de la sala"
	sala ifNotNil:[self proyectoQueLaRequirio imputarCosto: sala costo]  ifNil: [^'No se reservo una sala para la reunion'].

	"Imputa el costo del transporte $50 x persona"
	self proyectoQueLaRequirio imputarCosto: ((personasDeOtrosProyectos select:[:unaPersona | unaPersona edificioEnElQueTrabaja ~= sala edificioEnElQueSeEncuentra]) size) * 50.

	"Imputa el costo de las personas que asisten"
	personasDeOtrosProyectos do:[ :unaPersona | self proyectoQueLaRequirio imputarCosto: (unaPersona valorPorHoraDeTrabajo * duracion hours)].
		! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 22:47'!
conseguirFranjaHorariaComun
	| inicioFranjaComun finFranjaComun personaAux thisReunionEvent i |
	inicioFranjaComun := Time readFromString: '09:00'.
	finFranjaComun := Time readFromString: '18:00'.
	i := 1.

	(personas size) timesRepeat:
	[		
		personaAux := (personas at: i).
		personaAux horaEntrada > inicioFranjaComun
		ifTrue: [inicioFranjaComun:= personaAux horaEntrada].
		personaAux horaSalida < finFranjaComun
		ifTrue: [finFranjaComun:= personaAux horaSalida].
		i := i +1.
	].
	finFranjaComun < inicioFranjaComun
	ifTrue:[
		^false
		].
	horaInicio ifNotNil:[
		horaInicio < inicioFranjaComun
		ifTrue:[
			^false].
		(horaInicio addTime: duracion) < inicioFranjaComun
		ifTrue:[
			^false].
		horaInicio > finFranjaComun
		ifTrue:[
			^false].
	] ifNil:[
		horaInicio := inicioFranjaComun].	
	
	thisReunionEvent := Evento new.
	thisReunionEvent horaInicio: horaInicio.
	thisReunionEvent horaFin: (horaInicio addTime:  duracion).
	
	^thisReunionEvent! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:31'!
duracion
	^ duracion! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:31'!
duracion: anObject
	duracion := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 01:22'!
empresa
	^empresa! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 01:22'!
empresa: anObject
	empresa := anObject.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:22'!
fecha
	^ fecha! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:22'!
fecha: anObject
	fecha := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 23:53'!
fechaLibreEnAgendasPara: unEvento	
	| isValidDatePersonas isValidDateHerramientas isValidDateSala |
	
	unEvento fecha: self fecha.
	
	isValidDatePersonas := false.
	isValidDateHerramientas:= false.
	isValidDateSala:= false.
	
	[isValidDatePersonas & isValidDateHerramientas & isValidDateSala]
	whileFalse:
	[	
		self fecha: ((self fecha) addDays:1).
		unEvento fecha: self fecha.
		isValidDateHerramientas := self fechaLibreHerramientasPara: unEvento.
		isValidDatePersonas := self fechaLibrePersonasPara: unEvento.
		isValidDateSala := self fechaLibreSalaPara: unEvento.
	].
	
! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:02'!
fechaLibreHerramientasPara: unEvento	
	|herramientaAux hayHerramientas i |
	i = 1.
	hayHerramientas := true.
	(herramientas size) timesRepeat:
	[
		herramientaAux := herramientas at: i.
		((herramientaAux herramienta) hay: (herramientaAux cantidad) paraEvento: unEvento)ifFalse:[
			hayHerramientas := false.].
		i = i+1.
	].
	^hayHerramientas! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 23:57'!
fechaLibrePersonasPara: unEvento	
	|superAgendaPersonas personaAux i estanLibres |
		
	superAgendaPersonas := Agenda new.
	i = 1.
	(personas size) timesRepeat:
	[
		personaAux := personas at: i.
		(superAgendaPersonas eventos) addAll: ((personaAux agenda) eventosEnLaFecha: (self fecha)).
		i := i +1.	
	].
	estanLibres := [(unEvento seSuperPoneConAlgunOtroEvento: (superAgendaPersonas eventos)) not].
	^estanLibres
! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 01:29'!
fechaLibreSalaPara: unEvento
	| salaAux|
	sala ifNil: [salaAux := (self empresa)buscaSalaXEvento: unEvento.
		(salaAux) ifFalse:[
			^false
			].
		self sala: salaAux.
		^true
		] 
		 ifNotNil:[salaAux := sala estasLibreEnEsteEvento: unEvento.
			(salaAux) ifTrue:[
				^true
				].
			^false
		].
	
	
	
	
! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 19:22'!
herramientas
	^ herramientas! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:52'!
herramientas: anObject
	herramientas:= anObject.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:14'!
horaFin
	^horaFin.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:15'!
horaFin: unaHora
	horaFin:= unaHora.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:17'!
horaInicio
	^ horaInicio! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:15'!
horaInicio: unaHora
	horaInicio:= unaHora.! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:52'!
horarioEnElQuePuedeRealizarse
	| i personaAux thisReunionEvent superAgendaPersonas fechaAux|
	
	thisReunionEvent := self conseguirFranjaHorariaComun.
	(thisReunionEvent) ifFalse:[^'No existe un horario comun entre las personas solicitadas para la Reunion'].

	fechaAux := self fechaLibreEnAgendasPara: thisReunionEvent.
	
	thisReunionEvent fecha: fechaAux.
	
	self AgendarEnTodos.
	. 
	^ 'La Reunion ha sido puesta para el dia ',(thisReunionEvent fecha asString), ' a la hora ',(thisReunionEvent horaInicio asString),'. Los asistentes seran: ',((personas collect: [:e|e nombre]) inject: '' into: [:a :c | a,' ',c]).! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 18:36'!
initialize 
	requiereCatering :=false.
	personas := OrderedCollection new.
	herramientas:= OrderedCollection new.
	self fecha: Date today.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 20:41'!
personaQueLaConvoca
	^ personaQueLaConvoca! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:59'!
personaQueLaConvoca: unaPersona
	personaQueLaConvoca := unaPersona.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:03'!
personas
	^ personas! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:03'!
personas: anObject
	personas := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 21:00'!
proyectoQueLaRequirio
	^ personaQueLaConvoca proyectoAlQueEstaAsignado.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 19:30'!
requiereCatering
	^ requiereCatering | (personas anySatisfy:[:unaPersona | (unaPersona rol = 'Gerente') | (unaPersona rol = 'Project Leader')]).! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 18:14'!
requiereCatering: anObject
	requiereCatering := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 19:51'!
sala
	^ sala! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 19:51'!
sala: anObject
	sala := anObject! !
